/* -- THIS FILE IS GENERATED - DO NOT EDIT *//* -*- Mode: C; c-basic-offset: 4 -*- */

#include <Python.h>



#line 3 "./pytpfarsight.override"
#include <pygobject.h>

#include <gst/gst.h>

#include <telepathy-farsight/stream.h>
#include <telepathy-farsight/channel.h>

#include <telepathy-glib/dbus.h>
#include <telepathy-glib/channel.h>

#include "pygstminiobject.h"
#line 20 "./pytpfarsight.c"


/* ---------- types from other modules ---------- */
static PyTypeObject *_PyGObject_Type;
#define PyGObject_Type (*_PyGObject_Type)
static PyTypeObject *_PyGstMessage_Type;
#define PyGstMessage_Type (*_PyGstMessage_Type)


/* ---------- forward type declarations ---------- */
PyTypeObject PyTfChannel_Type;
PyTypeObject PyTfStream_Type;

#line 34 "./pytpfarsight.c"



/* ----------- TfChannel ----------- */

#line 24 "./pytpfarsight.override"
static int
_wrap_tf_channel_new(PyGObject *self, PyObject *args, PyObject *kwargs)
{
  static char *kwlist[] = { "connection_busname", "connection_path",
    "channel_path", NULL };

  char *busname, *connection_path, *channel_path;
  TpChannel *proxy = NULL;
  TpConnection *connection = NULL;
  TpDBusDaemon *dbus = NULL;
  GError *error = NULL;

  if (!PyArg_ParseTupleAndKeywords (args, kwargs, "sss:TfChannel.__init__",
      kwlist, &busname, &connection_path, &channel_path))
    return -1;

  dbus = tp_dbus_daemon_new (tp_get_bus ());
  /* FIXME Throw an exception */
  if (dbus == NULL)
    {
      PyErr_SetString (PyExc_RuntimeError, "Failed to connect to D-Bus");
      goto out;
    }

  connection = tp_connection_new (dbus, busname, connection_path, &error);
  if (connection == NULL)
    {
      pyg_error_check (&error);
      goto out;
    }

  proxy = tp_channel_new (connection, channel_path, NULL,
    TP_UNKNOWN_HANDLE_TYPE, 0, &error);

  if (proxy == NULL)
    {
      pyg_error_check (&error);
      goto out;
    }

  self->obj = G_OBJECT (tf_channel_new (proxy));

out:
  if (dbus != NULL)
    g_object_unref (dbus);

  if (connection != NULL)
    g_object_unref (connection);

  if (proxy != NULL)
    g_object_unref (proxy);

  return (self->obj == NULL) ? -1 : 0;
}

#line 96 "./pytpfarsight.c"


static PyObject *
_wrap_tf_channel_error(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "error", "message", NULL };
    int error;
    char *message;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"is:TfChannel.error", kwlist, &error, &message))
        return NULL;
    pyg_begin_allow_threads;
    tf_channel_error(TF_CHANNEL(self->obj), error, message);
    pyg_end_allow_threads;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_tf_channel_lookup_stream(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "stream_id", NULL };
    PyObject *py_stream_id = NULL;
    TfStream *ret;
    guint stream_id = 0;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O:TfChannel.lookup_stream", kwlist, &py_stream_id))
        return NULL;
    if (py_stream_id) {
        if (PyLong_Check(py_stream_id))
            stream_id = PyLong_AsUnsignedLong(py_stream_id);
        else if (PyInt_Check(py_stream_id))
            stream_id = PyInt_AsLong(py_stream_id);
        else
            PyErr_SetString(PyExc_TypeError, "Parameter 'stream_id' must be an int or a long");
        if (PyErr_Occurred())
            return NULL;
    }
    pyg_begin_allow_threads;
    ret = tf_channel_lookup_stream(TF_CHANNEL(self->obj), stream_id);
    pyg_end_allow_threads;
    /* pygobject_new handles NULL checking */
    return pygobject_new((GObject *)ret);
}

static PyObject *
_wrap_tf_channel_bus_message(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "message", NULL };
    int ret;
    PyGstMiniObject *message;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"O!:TfChannel.bus_message", kwlist, &PyGstMessage_Type, &message))
        return NULL;
    pyg_begin_allow_threads;
    ret = tf_channel_bus_message(TF_CHANNEL(self->obj), GST_MESSAGE(message->obj));
    pyg_end_allow_threads;
    return PyBool_FromLong(ret);

}

static const PyMethodDef _PyTfChannel_methods[] = {
    { "error", (PyCFunction)_wrap_tf_channel_error, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "lookup_stream", (PyCFunction)_wrap_tf_channel_lookup_stream, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "bus_message", (PyCFunction)_wrap_tf_channel_bus_message, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject PyTfChannel_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "tf.Channel",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyTfChannel_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)_wrap_tf_channel_new,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- TfStream ----------- */

static PyObject *
_wrap_tf_stream_error(PyGObject *self, PyObject *args, PyObject *kwargs)
{
    static char *kwlist[] = { "error", "message", NULL };
    int error;
    char *message;

    if (!PyArg_ParseTupleAndKeywords(args, kwargs,"is:TfStream.error", kwlist, &error, &message))
        return NULL;
    pyg_begin_allow_threads;
    tf_stream_error(TF_STREAM(self->obj), error, message);
    pyg_end_allow_threads;
    Py_INCREF(Py_None);
    return Py_None;
}

static PyObject *
_wrap_tf_stream_get_id(PyGObject *self)
{
    guint ret;

    pyg_begin_allow_threads;
    ret = tf_stream_get_id(TF_STREAM(self->obj));
    pyg_end_allow_threads;
    return PyLong_FromUnsignedLong(ret);
}

static const PyMethodDef _PyTfStream_methods[] = {
    { "error", (PyCFunction)_wrap_tf_stream_error, METH_VARARGS|METH_KEYWORDS,
      NULL },
    { "get_id", (PyCFunction)_wrap_tf_stream_get_id, METH_NOARGS,
      NULL },
    { NULL, NULL, 0, NULL }
};

PyTypeObject PyTfStream_Type = {
    PyObject_HEAD_INIT(NULL)
    0,                                 /* ob_size */
    "tf.Stream",                   /* tp_name */
    sizeof(PyGObject),          /* tp_basicsize */
    0,                                 /* tp_itemsize */
    /* methods */
    (destructor)0,        /* tp_dealloc */
    (printfunc)0,                      /* tp_print */
    (getattrfunc)0,       /* tp_getattr */
    (setattrfunc)0,       /* tp_setattr */
    (cmpfunc)0,           /* tp_compare */
    (reprfunc)0,             /* tp_repr */
    (PyNumberMethods*)0,     /* tp_as_number */
    (PySequenceMethods*)0, /* tp_as_sequence */
    (PyMappingMethods*)0,   /* tp_as_mapping */
    (hashfunc)0,             /* tp_hash */
    (ternaryfunc)0,          /* tp_call */
    (reprfunc)0,              /* tp_str */
    (getattrofunc)0,     /* tp_getattro */
    (setattrofunc)0,     /* tp_setattro */
    (PyBufferProcs*)0,  /* tp_as_buffer */
    Py_TPFLAGS_DEFAULT | Py_TPFLAGS_BASETYPE,                      /* tp_flags */
    NULL,                        /* Documentation string */
    (traverseproc)0,     /* tp_traverse */
    (inquiry)0,             /* tp_clear */
    (richcmpfunc)0,   /* tp_richcompare */
    offsetof(PyGObject, weakreflist),             /* tp_weaklistoffset */
    (getiterfunc)0,          /* tp_iter */
    (iternextfunc)0,     /* tp_iternext */
    (struct PyMethodDef*)_PyTfStream_methods, /* tp_methods */
    (struct PyMemberDef*)0,              /* tp_members */
    (struct PyGetSetDef*)0,  /* tp_getset */
    NULL,                              /* tp_base */
    NULL,                              /* tp_dict */
    (descrgetfunc)0,    /* tp_descr_get */
    (descrsetfunc)0,    /* tp_descr_set */
    offsetof(PyGObject, inst_dict),                 /* tp_dictoffset */
    (initproc)0,             /* tp_init */
    (allocfunc)0,           /* tp_alloc */
    (newfunc)0,               /* tp_new */
    (freefunc)0,             /* tp_free */
    (inquiry)0              /* tp_is_gc */
};



/* ----------- functions ----------- */

const PyMethodDef tf_functions[] = {
    { NULL, NULL, 0, NULL }
};

/* initialise stuff extension classes */
void
tf_register_classes(PyObject *d)
{
    PyObject *module;

    if ((module = PyImport_ImportModule("gobject")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGObject_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "GObject");
        if (_PyGObject_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name GObject from gobject");
            return;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gobject");
        return;
    }
    if ((module = PyImport_ImportModule("gst")) != NULL) {
        PyObject *moddict = PyModule_GetDict(module);

        _PyGstMessage_Type = (PyTypeObject *)PyDict_GetItemString(moddict, "Message");
        if (_PyGstMessage_Type == NULL) {
            PyErr_SetString(PyExc_ImportError,
                "cannot import name Message from gst");
            return;
        }
    } else {
        PyErr_SetString(PyExc_ImportError,
            "could not import gst");
        return;
    }


#line 341 "./pytpfarsight.c"
    pygobject_register_class(d, "TfChannel", TF_TYPE_CHANNEL, &PyTfChannel_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pygobject_register_class(d, "TfStream", TF_TYPE_STREAM, &PyTfStream_Type, Py_BuildValue("(O)", &PyGObject_Type));
    pyg_set_object_has_new_constructor(TF_TYPE_STREAM);
}
